<template>
    <el-date-picker
        class="pam-date cursor--pointer"
        popper-class="pam-date-popper"
        v-model="dateValue"
        :clearable="false"
        type="date"
        format="yyyy/MM/dd"
        placeholder="選擇日期"
        prefix-icon="icon-down"
        @change="changeDate"
    >
    </el-date-picker>
</template>

<script lang="ts">
import { Component, Emit, Prop, Vue, Watch } from "nuxt-property-decorator";

@Component
export default class UiDatePicker extends Vue {
    dateValue: Date | string = '';

    @Prop()
    defaultValue!: string;

    @Emit('changeDate')
    changeDate() {
        return this.dateValue;
    }

    @Watch('defaultValue', {immediate: true})
    updateDefault() {
        if (this.defaultValue) {
            this.dateValue = new Date(this.defaultValue);
            this.changeDate();
        }
    }
}
</script>